﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using System.Data.OleDb;


namespace FlexGridColumnsAllowFocus
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Steps:
        /// 1. Initialize a collection which stores the index of all locked columns
        /// 2. Initialize a collection of checkboxes which will change the value of above described collection
        /// 3. Lock the collection by implementing business logic in two events:
        ///    3.1. BeforeMouseDown
        ///    3.2. BeforeRowColChange
        /// </summary>

        List<bool> _lbFocusCols = new List<bool>();
        List<CheckBox> _lchkFocusColsCheck = new List<CheckBox>();

        public Form1()
        {
            InitializeComponent();
            this.c1FlexGrid1.DataSource = this.GetTable();
            foreach (Column col in c1FlexGrid1.Cols)
            {
                if (col.Index >= (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen))
                {
                    CheckBox chk = new CheckBox();
                    chk.Width = 10;
                    chk.Height = 10;
                    chk.Text = null;
                    chk.Checked = false;
                    chk.Visible = false;
                    chk.Tag = (col.Index - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen)).ToString();
                    chk.CheckedChanged += new EventHandler(chk_CheckedChanged);
                    this.c1FlexGrid1.Controls.Add(chk);
                    _lchkFocusColsCheck.Add(chk);
                    _lbFocusCols.Add(false);
                }
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            this.c1FlexGrid1.Paint += new PaintEventHandler(c1FlexGrid1_Paint);
            this.c1FlexGrid1.AfterDragColumn += new DragRowColEventHandler(c1FlexGrid1_AfterDragColumn);
            this.c1FlexGrid1.BeforeMouseDown += new BeforeMouseDownEventHandler(c1FlexGrid1_BeforeMouseDown);
            this.c1FlexGrid1.MouseMove += new MouseEventHandler(c1FlexGrid1_MouseMove);
        }
        void chk_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox chk = (CheckBox)sender;
            if (chk.Checked == true)
                chk.Visible = true;
            else
                chk.Visible = false;
            _lbFocusCols[Convert.ToInt32(chk.Tag.ToString())] = Convert.ToBoolean(chk.Checked.ToString());
            this.c1FlexGrid1.Focus();
            this.c1FlexGrid1.BeforeRowColChange += new RangeEventHandler(c1FlexGrid1_BeforeRowColChange);
            if (this.c1FlexGrid1.Selection.c1 == Convert.ToInt32(chk.Tag.ToString()) + 1)
            {
                bool flagger = false;
                foreach (bool b in _lbFocusCols)
                {
                    if (b == false)
                    {
                        flagger = true;
                    }
                }
                if (flagger == true)
                {
                    bool rightFlag = false;
                    bool leftFlag = false;
                    for (int i = Convert.ToInt32(chk.Tag.ToString()); i < _lbFocusCols.Count; i++)
                    {
                        if (_lbFocusCols[i] == false)
                        {
                            rightFlag = true;
                        }
                    }
                    if (rightFlag)
                    {
                        while ((_lbFocusCols[this.c1FlexGrid1.Selection.c1 - 1]) && (this.c1FlexGrid1.Selection.c1 < this.c1FlexGrid1.Cols.Count - 1))
                        {
                            try
                            {
                                this.c1FlexGrid1.Select(this.c1FlexGrid1.Selection.r1, this.c1FlexGrid1.Selection.c1 + 1);
                            }
                            catch
                            {
                            }
                        }
                    }
                    else
                    {
                        leftFlag = true;
                    }


                    if (leftFlag || (this.c1FlexGrid1.Selection.c1 == this.c1FlexGrid1.Cols.Count - 1 && _lbFocusCols[this.c1FlexGrid1.Selection.c1 - 1]))
                    {
                        bool flag = false;
                        int col = 0, c = 0;
                        foreach (bool b in _lbFocusCols)
                        {
                            c++;
                            if (b == false)
                            {
                                flag = true;
                                col = c;
                            }
                        }
                        if (flag == true)
                        {
                            this.c1FlexGrid1.Select(this.c1FlexGrid1.Selection.r1, col);
                        }
                        else
                        {
                            this.c1FlexGrid1.FinishEditing();
                        }

                    }
                }
                else
                {
                    this.c1FlexGrid1.FinishEditing();
                }

            }
        }
        void c1FlexGrid1_BeforeRowColChange(object sender, RangeEventArgs e)
        {
            if (e.NewRange.IsSingleCell)
            {
                int NewColumn = e.NewRange.c1;
                int OldColumn = e.OldRange.c1;
                if (OldColumn != NewColumn)
                {
                    if (_lbFocusCols[NewColumn - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen)] == false)
                    {
                        //Next Column Is Not Locked
                    }
                    else
                    {
                        e.Cancel = true;
                        c1FlexGrid1.Select(e.NewRange.r1, FindNextUnlockedCol(OldColumn, NewColumn));
                    }
                }
            }
        }
        int FindNextUnlockedCol(int OldColumn, int NewColumn)
        {
            if (OldColumn < NewColumn)
            {
                while (_lbFocusCols[NewColumn - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen)] == true)
                {
                    NewColumn++;
                    if (NewColumn == c1FlexGrid1.Cols.Count)
                    {
                        return OldColumn;
                    }
                }
                return NewColumn;
            }
            else
            {
                while (_lbFocusCols[NewColumn - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen)] == true)
                {
                    NewColumn--;
                    if (NewColumn == (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen - 1))
                    {
                        return OldColumn;
                    }
                }
                return NewColumn;
            }
        }
        void c1FlexGrid1_BeforeMouseDown(object sender, BeforeMouseDownEventArgs e)
        {
            C1.Win.C1FlexGrid.HitTestInfo hit = c1FlexGrid1.HitTest(e.X, e.Y);
            if (hit.Type == HitTestTypeEnum.Cell)
            {
                if (_lbFocusCols[(hit.Column - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen))] == true)
                {
                    if (hit.Row != 0)
                        e.Cancel = true;
                }
            }
        }
        void c1FlexGrid1_AfterDragColumn(object sender, DragRowColEventArgs e)
        {
            int NewPosition = e.Position - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen);
            int OldPosition = e.Col - (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen);

            bool temp = _lchkFocusColsCheck[NewPosition].Checked;
            _lchkFocusColsCheck[NewPosition].Checked = _lchkFocusColsCheck[OldPosition].Checked;
            _lchkFocusColsCheck[OldPosition].Checked = temp;

            _lbFocusCols[NewPosition] = _lchkFocusColsCheck[NewPosition].Checked;
            _lbFocusCols[OldPosition] = _lchkFocusColsCheck[OldPosition].Checked;
            c1FlexGrid1.Refresh();
        }
        void c1FlexGrid1_Paint(object sender, PaintEventArgs e)
        {
            int index = 0;
            foreach (C1.Win.C1FlexGrid.Column col in c1FlexGrid1.Cols)
            {
                if (col.Index >= (c1FlexGrid1.Cols.Fixed + c1FlexGrid1.Cols.Frozen))
                {
                    _lchkFocusColsCheck[index].Location = new Point(c1FlexGrid1.GetCellRect(0, col.Index).Right - 3 * _lchkFocusColsCheck[index].Width,
                        c1FlexGrid1.GetCellRect(0, col.Index).Bottom - _lchkFocusColsCheck[index].Height - 5);
                    index++;
                }
            }
        }
        void c1FlexGrid1_MouseMove(object sender, MouseEventArgs e)
        {
            C1.Win.C1FlexGrid.HitTestInfo hit = c1FlexGrid1.HitTest(e.X, e.Y);
            if (hit.Type == HitTestTypeEnum.ColumnHeader)
            {
                int i = 0;
                foreach (CheckBox chk in _lchkFocusColsCheck)
                {
                    if (chk.Checked == true)
                    {
                        chk.Visible = true;
                    }
                    if (chk.Checked == false)
                    {
                        if (i == (hit.Column - this.c1FlexGrid1.Cols.Fixed - this.c1FlexGrid1.Cols.Frozen))
                        {
                            chk.Visible = true;
                        }
                        else
                        {
                            chk.Visible = false;
                        }
                    }
                    i++;
                }
            }
            else
            {
                foreach (CheckBox chk in _lchkFocusColsCheck)
                {
                    if (chk.Checked == true)
                    {
                        chk.Visible = true;
                    }
                    else
                    {
                        chk.Visible = false;
                    }
                }
            }
        }
        private DataTable GetTable()
        {            
            OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Users\stduser\Documents\ComponentOne Samples\Common\C1NWind.mdb;Persist Security Info=False");
            OleDbDataAdapter adap = new OleDbDataAdapter("Select top 30 * from Orders", con);
            con.Open();
            DataTable ordersTable = new DataTable();
            adap.Fill(ordersTable);
            con.Close();
            return ordersTable;
            
        }
        private bool GetFocus(int index)
        {
            return _lbFocusCols[index - this.c1FlexGrid1.Cols.Fixed - this.c1FlexGrid1.Cols.Frozen];
        }
        private void SetFocus(int index)
        {
            this._lchkFocusColsCheck[index - this.c1FlexGrid1.Cols.Fixed - this.c1FlexGrid1.Cols.Frozen].Checked = true;
        }

    }
}
